*DECK DRAGON
      PROGRAM DRAGON
      IMPLICIT         NONE
*----
*  INPUT/OUTPUT UNITS
*----
      INTEGER          IINP,IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IINP=5,IOUT=6,NAMSBR='DRAGON')
*----
*  MEMORY ALLOCATION
*----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
*----
*  VARIABLES FOR DRAGON VERSION
*----
      INTEGER          IMVERS
*----
*  VARIABLES FOR DATA STRUCTURES
*----
      INTEGER          MAXENT
      PARAMETER       (MAXENT=64)
      CHARACTER        HENTRY(MAXENT)*12
      INTEGER          IENTRY(MAXENT),JENTRY(MAXENT),KENTRY(MAXENT)
*----
*  GAN-2000 PARAMETERS
*----
      INTEGER          CLECST
      EXTERNAL         CLECST
      INTEGER          KERNEL,KDRDRV
*----
*  DIMENSION FOR MODULE DATA
*----
      INTEGER          NMODXT
      PARAMETER       (NMODXT=19)
      CHARACTER        CMODXT(NMODXT)*12
*----
*  LOCAL VARIABLES
*----
      CHARACTER        NAMOUT*20,DATE*64,REV*48
      INTEGER          IMODUL,NENTRY,ILEVEL,IPRINT,IOS,IBLANK,IER
      DATA             CMODXT
     >   /'ASM:        ','COMPO:      ','EDI:        ','EVO:        ',
     >    'EXCELT:     ','FLU:        ','GEO:        ','INFO:       ',
     >    'USS:        ','LIB:        ','MAC:        ','MCCGT:      ',
     >    'BIVACT:     ','SHI:        ','SYBILT:     ','SNT:        ',
     >    'NCR:        ','NXT:        ','PSP:        '/
*----
*  VARIABLES INITIALISATION
*----
      NAMOUT=' '
      IMODUL=0
      NENTRY=0
      ILEVEL= 0
      IPRINT= 0
      IOS=0
      IBLANK=0
*----
*  VERSION INFORMATION RECOVERED FROM CVS or SVN
*----
      IMVERS=4
      CALL KDRVER(REV,DATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,REV,DATE
      WRITE(IOUT,6010) NAMSBR
*----
*  WHILE LOOP UNTIL ILEVEL = 0
*----
 100  CONTINUE
        IMODUL= KERNEL(CMODXT,NMODXT,ILEVEL,MAXENT,
     >                 CLECST,IPRINT,
     >                 NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*----
*  RUN FINISHED IF ILEVEL = 0
*----
        IF(ILEVEL .EQ. 0) GO TO 105
        IF(IMODUL .LE. 0 .OR. IMODUL .GT. NMODXT) THEN
*----
*  ILLEGAL VALUE FOR IMODUL RETURNED
*  RETURN VALUE OF IMODUL AND ABORT
*----
          WRITE(IOUT,9000) NAMSBR,IMODUL
          CALL XABORT(NAMSBR//': KERNEL ERROR')
        ELSE
*----
*  CALL APPROPRIATE MODULE
*----
          IER= KDRDRV(CMODXT(IMODUL),NENTRY,HENTRY,IENTRY,
     >                JENTRY,KENTRY)
          IF(IER.NE.0) CALL XABORT(NAMSBR//': KDRDRV FAILURE WITH '//
     >    'OPERATOR '''//CMODXT(IMODUL)//'''.')
*----
*  GO TO PROCESS NEXT MODULE
*----
        ENDIF
      GO TO 100
*----
*  ALL MODULES PROCESSED
*----
 105  CONTINUE
      WRITE(IOUT,6030) NAMSBR,IMVERS,REV
      STOP
*----
*  FORMATS
*----
 6000 FORMAT(
     > ' DDDDDD   RRRRRR     AAA     GGGGG    OOOOO   NN     NN'/
     > ' DDDDDDD  RRRRRRR   AAAAA   GGGGGGG  OOOOOOO  NNN    NN'/
     > ' DD   DD  RR   RR  AA   AA  GG       OO   OO  NNNN   NN'/
     > ' DD   DD  RRRRRR   AA   AA  GG  GGG  OO   OO  NN NN  NN'/
     > ' DD   DD  RRRR     AAAAAAA  GG  GGG  OO   OO  NN  NN NN'/
     > ' DD   DD  RR RR    AAAAAAA  GG   GG  OO   OO  NN   NNNN'/
     > ' DDDDDDD  RR  RR   AA   AA  GGGGGGG  OOOOOOO  NN    NNN'/
     > ' DDDDDD   RR   RR  AA   AA   GGGGG    OOOOO   NN     NN'//
     > ' VERSION ',A6,I2,2X,A,4X,A/
     > ' GROUPE D''ANALYSE NUCLEAIRE'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL'///)
 6010 FORMAT(
     > ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     > ' --------------------------------------------'/
     > ' Copyright (C) 2002 Ecole Polytechnique de Montreal '/
     > ' This library is free software; you can redistribute it' /
     > ' and/or modify it under the terms of the GNU Lesser General' /
     > ' Public License as published by the Free Software Foundation;' /
     > ' either version 2.1 of the License, or (at your option) any' /
     > ' later version '////)
 6030 FORMAT(//1X,'NORMAL END OF EXECUTION FOR ',A6,I2,2X,A/
     >         1X,'CHECK FOR WARNING IN LISTING'/
     >         1x,'BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
 9000 FORMAT('->@ERROR FROM KERNEL IN ',A6,' CODE = ',I10)
      END
