*DECK EDITXS
      SUBROUTINE EDITXS(IPEDIT,IWGOXS,IPRINT,NGCOND,NL    ,NBNISO,
     >                  CTITLE,IMRG  ,ENERGY,ISNNAM,ISNNRF,MIXISN,
     >                  AWRISN,DENISN,TMPISN,VOLISN,EMJISN,AVGVEL,
     >                  LOCISO,IJJ   ,NJJ   )
C
C---------------------------  EDITXS  ---------------------------------
C
C  TRANSFER INFORMATION FROM EDIT TO ISOTXS
C------------------------------------------
C
C
C  INPUT PARAMETERS:
C       IPEDIT   : POINTER TO EDIT                    I
C       IWGOXS   : UNIT FOR ISOTXS                    I
C       IPRINT   : PRINT LEVEL                        I
C       NGCOND   : NUMBER OF ENERGY GROUP             I
C       NL       : ANISOTROPY ORDER                   I
C       NBNISO   : NUMBER OF EDIT ISOTOPES            I
C       CTITLE   : TITLE                              C*72
C       IMRG     : MIXTURE TO CONSIDER                I
C       ENERGY   : ENERGY GROUPS                      R(NGCOND+1)
C       ISNNAM   : NAMES OF EDIT ISOTOPES.            I(3,NBNISO)
C       ISNNRF   : REFERENCE NAMES OF EDIT ISOTOPES   I(3,NBNISO)
C       MIXISN   : MIXTURE NUMBER FOR EDIT ISOTOPES   I(NBNISO)
C       AWRISN   : AWR FOR EDIT ISOTOPES              R(NBNISO)
C       DENISN   : DENSITY FOR EDIT ISOTOPES          R(NBNISO)
C       TMPISN   : TEMPERATURE FOR EDIT ISOTOPES      R(NBNISO)
C       VOLISN   : VOLUME RATIO FOR EDIT ISOTOPES     R(NBNISO)
C       EMJISN   : ENERGY FOR EDIT ISOTOPES           R(NBNISO)
C                  M-JOULES FOR 10**24 FISSION
C       AVGVEL   : NEUTRON AVERAGE VELOCITY           R(NGCOND)
C       LOCISO   : ISOTOPE LOCALISATION VECTOR        I(NBNISO)
C       IJJ      : POSITION OF IN GROUP SCATTERING    I(NGCOND)
C       NJJ      : NUMBER OF SCATTERING GROUPS        I(NGCOND)
C
C----------------AUTHOR   : M.T. SISSAOUI, 28/08/97 ------------
C----------------MODIFIED : G. MARLEAU,    10/09/97 ------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN,NFILNA,NFILCN,MXMULT,NFILMD
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NFILNA=3,NFILCN=8,MXMULT=2,
     >            NFILMD=1+NFILNA*MXMULT,NAMSBR='EDITXS')
C----
C FUNCTIONS
C----
      DOUBLE PRECISION XDRCST
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IWGOXS,IPRINT,NGCOND,NL,NBNISO,IMRG
      INTEGER     ISNNAM(3,NBNISO),ISNNRF(3,NBNISO),MIXISN(NBNISO),
     >            LOCISO(NBNISO),IJJ(NGCOND),NJJ(NGCOND)
      CHARACTER   CTITLE*72
      REAL        ENERGY(NGCOND+1),AWRISN(NBNISO),DENISN(NBNISO),
     >            TMPISN(NBNISO),VOLISN(NBNISO),EMJISN(NBNISO),
     >            AVGVEL(NGCOND)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IRCHI,JRCHI,IREC,IRECGI,IRECPX,IRECPS
C----
C  LOCAL PARAMETERS
C----
      CHARACTER     CM*2,NAMISO*12,FMTRD*5,CIDENT*8,HABSID*8,
     >              HIDENT*8,HMAT*8,CDUM*8
      INTEGER       IFILID(NFILMD),IFILCN(NFILCN),NEXTRI,
     >              MXGDSC,MXGUSC,ICHIST,ISO,IFIL,JSO,IGROUP,
     >              IL,INFL,IFTL,IRECG  ,IRECNB ,IRECIB ,
     >              MRECGI,MRECPX,MRECPS,IRECP,JRECP,ILCMTY ,
     >              ILENG,IRECW,IW,IGR,NRECWR,JFZ,
     >              JFX,ITC,NBISO,MULTA6,IRECL,
     >              ITITLE,IC6TIT,JVAR,IRECWR,MRECWR
      DOUBLE PRECISION NMASS
      LOGICAL       LFIS
C----
C  SET ISOTXS FILE DIMENSIONING RECORD
C  MULTA6 = NUMBER OF INTEGER WORDS TO STORE
C           CHARACTER*6 VARIABLE
C  FMTRD  = FORMAT TO STORE CHARACTER*6 VARIABLE
C           IN INTEGER WORDS
C----
      PARAMETER  (MULTA6=2,FMTRD='(2A4)')
C----
C  DATA
c----
      CHARACTER     CFILNC(NFILNA)*10
      SAVE          CFILNC
      DATA         (CFILNC(IFIL),IFIL=1,NFILNA)
     >             /'ISOTXS','DRAGON','971124'/
C------
C  EVALUATE THE ISOTOPE LOCALISATION VECTOR AND
C  MAXIMUM NUMBER OF UPSCATTER AND DOWN SCATTER GROUPS
C------
      NMASS=XDRCST('Neutron mass','amu')
      NEXTRI=0
      MXGDSC=0
      MXGUSC=0
      ICHIST=2
      ISO=0
C----
C  ALLOCATE MEMORY TO STORE ISOTOPIC FISSION SPECTRUM
C----
      CALL SETARA(RBASE,NGCOND,IRCHI)
      CALL SETARA(RBASE,NGCOND,JRCHI)
      DO 120 JSO=1,NBNISO
        IF(MIXISN(JSO) .EQ. IMRG) THEN
          ISO=ISO+1
          LOCISO(ISO)=NEXTRI
          NEXTRI=NEXTRI+2+NL
          WRITE(NAMISO,'(3A4)') (ISNNAM(ITC,JSO),ITC=1,3)
          CALL LCMSIX(IPEDIT,NAMISO,ILCMUP)
C----
C  TEST IF ALL FISSION PRODUCTION SPECTRUM IDENTICAL
C  ICHIST = 2 -> NO FISSION SPECTRUM FOUND
C  ICHIST = 1 -> ALL FISSION SPECTRUN IDENTICAL
C  ICHIST = 0 -> AT LEAST 2 FISSION SPECTRUM ARE DIFFERENT
C----
          CALL LCMLEN(IPEDIT,'CHI',ILENG,ILCMTY)
          IF(ILENG .NE. 0) THEN
            IF(ICHIST .EQ. 2) THEN
              CALL LCMGET(IPEDIT,'CHI',RBASE(IRCHI))
              ICHIST=1
            ELSE IF(ICHIST .EQ. 1) THEN
              CALL LCMGET(IPEDIT,'CHI',RBASE(JRCHI))
              DO 121 IGROUP=0,NGCOND-1
                IF(RBASE(JRCHI+IGROUP) .NE. RBASE(IRCHI+IGROUP)) THEN
                  ICHIST =0
                  GO TO 125
                ENDIF
 121          CONTINUE
 125          CONTINUE
            ENDIF
          ENDIF
          DO 130 IL=1,NL
            WRITE(CM,'(I2.2)') IL-1
            CALL LCMLEN(IPEDIT,'SCAT'//CM,ILENG,ILCMTY)
            IF(ILENG .NE. 0) THEN
C----
C  DATA EXISTS FOR THIS SCATTERING LEVEL FOR THIS ISOTOPE
C  READ NJJ AND IJJ
C    IJJ(IGTO) IS MAXIMUM GROUP NUMBER
C      WITH SCATTERING TO "IGTO" GROUP
C    NJJ(IGTO) IS NUMBER OF GROUPS
C      WITH SCATTERING TO "IGTO" GROUP
C  DETERMINE MAXIMUM NUMBER OF UP-SCATTERING GROUPS
C  DETERMINE MAXIMUM NUMBER OF DOWN-SCATTERING GROUPS
C----
              CALL LCMGET(IPEDIT,'NJJS'//CM,NJJ)
              CALL LCMGET(IPEDIT,'IJJS'//CM,IJJ)
              DO 140 IGROUP=1,NGCOND
                MXGUSC=MAX(MXGUSC,IJJ(IGROUP)-IGROUP)
                MXGDSC=MAX(MXGDSC,
     >                 IGROUP+NJJ(IGROUP)-IJJ(IGROUP)-1)
 140          CONTINUE
            ENDIF
 130      CONTINUE
C----
C  RECOVER AVERAGED VELOCITIES
C----
          CALL LCMLEN(IPEDIT,'OVERV',ILENG,ILCMTY)
          IF(ILENG .GT. 0) CALL LCMGET(IPEDIT,'OVERV',AVGVEL)
          CALL LCMSIX(IPEDIT ,NAMISO,ILCMDN)
        ENDIF
 120  CONTINUE
      CALL RLSARA(RBASE(JRCHI))
C----
C  IF ICHIST = 2 SET DEFAULT FISSION SPECTRUM ALL TO 0.0
C  AND USE A SINGLE CHI VECTOR
C----
      IF(ICHIST .EQ. 2) THEN
        CALL XDRSET(RBASE(IRCHI),NGCOND,0.0)
        ICHIST = 1
      ENDIF
      NBISO=ISO
C----
C     FILE IDENTIFICATION-RECORD 1
C----
      NRECWR=1+NFILNA*MULTA6
      JFZ=0
      DO 150 IFIL=1,NFILNA
        JFX=JFZ+1
        JFZ=JFZ+MULTA6
        READ(CFILNC(IFIL),FMTRD)
     >    (IFILID(JVAR),JVAR=JFX,JFZ)
 150  CONTINUE
      IFILID(NRECWR)=1
C-----
C  TRANSFER INFORMATION TO ISOTXS
C----
      IRECWR=1
      CALL XDRITE(IWGOXS,IRECWR,IFILID,NRECWR)
C----
C     FILE CONTROL-RECORD 2
C----
      IFILCN(1)=NGCOND
      IFILCN(2)=NBISO
      IFILCN(3)=MXGUSC
      IFILCN(4)=MXGDSC
      IFILCN(5)=NL-1
      IFILCN(6)=ICHIST
      IFILCN(7)=NL
      IFILCN(8)=1
C-----
C  TRANSFER INFORMATION TO ISOTXS
C----
      IRECWR=IRECWR+1
      NRECWR=NFILCN
      CALL XDRITE(IWGOXS,IRECWR,IFILCN,NRECWR)
C----
C     FILE DATA-RECORD 3
C----
      MRECWR=(NBISO+12)*MULTA6+1+NBISO+(2+ICHIST)*NGCOND
      CALL SETARA(IBASE,MRECWR,IREC)
      CALL XDRSET(IBASE(IREC),MRECWR,0)
      IRECL=IREC
      ITITLE=1
      DO 160 IC6TIT=1,12
        CIDENT=CTITLE(ITITLE:ITITLE+5)//'  '
        ITITLE=ITITLE+6
        READ(CIDENT,FMTRD)
     >    (IBASE(JVAR),JVAR=IRECL,IRECL+MULTA6-1)
        IRECL=IRECL+MULTA6
 160  CONTINUE
      DO 170 JSO=1,NBNISO
        IF(MIXISN(JSO).EQ.IMRG) THEN
          WRITE(NAMISO,'(3A4)') (ISNNAM(ITC,JSO),ITC=1,3)
          CIDENT=NAMISO(1:6)//'  '
          READ(CIDENT,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECL,IRECL+MULTA6-1)
          IRECL=IRECL+MULTA6
        ENDIF
 170  CONTINUE
C----
C  SAVE SET CHI IF REQUIRED
C----
      IF(ICHIST .EQ. 1) THEN
        DO 122 IGR=0,NGCOND-1
          RBASE(IRECL)=RBASE(IRCHI+IGR)
          IRECL=IRECL+1
 122    CONTINUE
      ENDIF
C----
C  SAVE AVERAGE NEUTRON VELOCITY
C----
      DO 180 IGR=1,NGCOND
        RBASE(IRECL)=1.0/AVGVEL(IGR)
        IRECL=IRECL+1
 180  CONTINUE
C----
C  SAVE ENERGY GROUP
C----
      DO 181 IGR=1,NGCOND+1
        RBASE(IRECL)=ENERGY(IGR)
        IRECL=IRECL+1
 181  CONTINUE
C----
C  TRANSFER LOCISO IN RECORD VECTOR
C----
      DO 190 ISO=1,NBISO
        IBASE(IRECL)=LOCISO(ISO)
        IRECL=IRECL+1
 190  CONTINUE
C-----
C  TRANSFER INFORMATION TO ISOTXS
C----
      IRECWR=IRECWR+1
      NRECWR=MRECWR
      CALL XDRITE(IWGOXS,IRECWR,IBASE(IREC),NRECWR)
      CALL RLSARA(IBASE(IREC))
C----
C  ISOTOPE CONTROL AND GROUP INDEPENDENT DATA
C----
      MRECGI=3*MULTA6+17+NL*(2*NGCOND+2)
      CALL SETARA(IBASE,MRECGI,IRECGI)
      MRECPX=10*NGCOND
      CALL SETARA(IBASE,MRECPX,IRECPX)
      MRECPS=NGCOND*NGCOND
      CALL SETARA(IBASE,MRECPS,IRECPS)
      ISO=0
      DO 200 JSO=1,NBNISO
        IF(MIXISN(JSO).EQ.IMRG) THEN
          ISO=ISO+1
          CALL XDRSET(IBASE(IRECGI),MRECGI,0)
          IRECG=IRECGI
          WRITE(NAMISO,'(3A4)') (ISNNAM(ITC,JSO),ITC=1,3)
          LFIS=.TRUE.
          CALL LCMSIX(IPEDIT,NAMISO,1)
          HABSID=NAMISO(1:6)//'  '
          IF(IPRINT.GE.1) WRITE(IOUT,6000) HABSID(1:6),LOCISO(ISO)
          READ(HABSID,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECG,IRECG+MULTA6-1)
          IRECG=IRECG+MULTA6
          HIDENT='DRAGON  '
          READ(HIDENT,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECG,IRECG+MULTA6-1)
          IRECG=IRECG+MULTA6
          WRITE(NAMISO,'(3A4)') (ISNNRF(ITC,JSO),ITC=1,3)
          HMAT=NAMISO(1:6)//'  '
          READ(HMAT,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECG,IRECG+MULTA6-1)
          IRECG=IRECG+MULTA6
          RBASE(IRECG)=AWRISN(JSO)*NMASS
          RBASE(IRECG+1)=EMJISN(JSO)*1.0E-18
          RBASE(IRECG+3)=TMPISN(JSO)
          RBASE(IRECG+5)=DENISN(JSO)
          IBASE(IRECG+7)=1
          CALL LCMLEN(IPEDIT,'NUSIGF',ILENG,ILCMTY)
          IF(ILENG .NE. 0) THEN
            CALL LCMGET(IPEDIT,'NUSIGF',RBASE(IRECPX))
C----
C  TEST IF FISSION ALL 0.0
C--
            INFL=IRECPX
            DO 201 IGROUP=1,NGCOND
              IF(RBASE(INFL).NE.0.0) THEN
                IBASE(IRECG+8)=MOD(ICHIST+1,2)
                GO TO 205
              ENDIF
              INFL=INFL+1
 201        CONTINUE
            LFIS=.FALSE.
 205        CONTINUE
          ENDIF
          CALL LCMLEN(IPEDIT,'N2N',ILENG,ILCMTY)
          IF(ILENG .NE. 0) IBASE(IRECG+11)=1
          IBASE(IRECG+14)=1
          IBASE(IRECG+15)=1
          CALL LCMLEN(IPEDIT,'STRD X',ILENG,ILCMTY)
          IF(ILENG .NE. 0) IBASE(IRECG+16)=3
          IRECG=IRECG+17
          DO 210 IL=1,NL
            IBASE(IRECG)=IL-1
            IBASE(IRECG+NL)=1
            IRECG=IRECG+1
 210      CONTINUE
          IRECG=IRECG+NL
          IRECNB=IRECG
          IRECIB=IRECNB+NL*NGCOND
          DO 220 IL=1,NL
            WRITE(CM,'(I2.2)') IL-1
            CALL LCMLEN(IPEDIT,'SCAT'//CM,ILENG,ILCMTY)
            IF(ILENG .NE. 0) THEN
              CALL LCMGET(IPEDIT,'NJJS'//CM,NJJ)
              CALL LCMGET(IPEDIT,'IJJS'//CM,IJJ)
              DO 230 IGROUP=1,NGCOND
                IBASE(IRECNB)=NJJ(IGROUP)
                IBASE(IRECIB)=IJJ(IGROUP)-IGROUP+1
                IRECNB=IRECNB+1
                IRECIB=IRECIB+1
 230          CONTINUE
            ELSE
              DO 240 IGROUP=1,NGCOND
                IBASE(IRECNB)=1
                IBASE(IRECIB)=1
                IRECNB=IRECNB+1
                IRECIB=IRECIB+1
 240          CONTINUE
            ENDIF
 220      CONTINUE
          IRECG=IRECG+2*NL*NGCOND
C-----
C  TRANSFER INFORMATION TO ISOTXS
C----
          IF(IPRINT.GE.10) THEN
            IRECW=IRECGI
            WRITE(CDUM,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECW,IRECW+MULTA6-1)
            HABSID=CDUM
            IRECW=IRECW+MULTA6
            WRITE(CDUM,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECW,IRECW+MULTA6-1)
            HIDENT=CDUM
            IRECW=IRECW+MULTA6
            WRITE(CDUM,FMTRD)
     >      (IBASE(JVAR),JVAR=IRECW,IRECW+MULTA6-1)
            HMAT=CDUM
            IRECW=IRECW+MULTA6
            WRITE(IOUT,6001) HABSID(1:6),HIDENT(1:6),HMAT(1:6),
     >        (RBASE(IW),IW=IRECW,IRECW+5),
     >        (IBASE(IW),IW=IRECW+6,IRECW+16)
          ENDIF
          IRECWR=IRECWR+1
          NRECWR=MRECGI
          CALL XDRITE(IWGOXS,IRECWR,IBASE(IRECGI),NRECWR)
C------
C  PRINCIPAL CROSS SECTIONS
C------
          CALL XDRSET(RBASE(IRECPX),MRECPX,0.0)
          IRECP=IRECPX
          JRECP=IRECP+NGCOND
          CALL LCMLEN(IPEDIT,'NTOT0',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'NTOT0',RBASE(JRECP))
          CALL LCMLEN(IPEDIT,'STRD',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'STRD',RBASE(IRECP))
          IRECP=IRECP+2*NGCOND
          CALL LCMLEN(IPEDIT,'NG',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'NG',RBASE(IRECP))
          IRECP=IRECP+NGCOND
          CALL LCMLEN(IPEDIT,'NFTOT',ILENG,ILCMTY)
          IF(ILENG .NE. 0) THEN
            IFTL=IRECP
            CALL LCMGET(IPEDIT,'NFTOT',RBASE(IRECP))
            IRECP=IRECP+NGCOND
            INFL=IRECP
            CALL LCMGET(IPEDIT,'NUSIGF',RBASE(IRECP))
            IRECP=IRECP+NGCOND
C----
C  COMPUTE NU FROM NUSIGF/NFTOT
C--
            DO 250 IGROUP=1,NGCOND
              IF(RBASE(IFTL).NE.0.0) THEN
                RBASE(INFL)=RBASE(INFL)/RBASE(IFTL)
              ENDIF
              IFTL=IFTL+1
              INFL=INFL+1
 250        CONTINUE
          ENDIF
          IF(ICHIST .EQ. 0 ) THEN
            CALL LCMLEN(IPEDIT,'CHI',ILENG,ILCMTY)
            IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'CHI',RBASE(IRECP))
            IRECP=IRECP+NGCOND
          ENDIF
          CALL LCMLEN(IPEDIT,'N2N',ILENG,ILCMTY)
          IF(ILENG .NE. 0) THEN
            CALL LCMGET(IPEDIT,'N2N',RBASE(IRECP))
            IRECP=IRECP+NGCOND
          ENDIF
          CALL LCMLEN(IPEDIT,'STRD X',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'STRD X',RBASE(IRECP))
          IRECP=IRECP+NGCOND
          CALL LCMLEN(IPEDIT,'STRD Y',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'STRD Y',RBASE(IRECP))
          IRECP=IRECP+NGCOND
          CALL LCMLEN(IPEDIT,'STRD Z',ILENG,ILCMTY)
          IF(ILENG .NE. 0) CALL LCMGET(IPEDIT,'STRD Z',RBASE(IRECP))
          IRECP=IRECP+NGCOND
          IRECWR=IRECWR+1
          NRECWR=IRECP-IRECPX
          CALL XDRITE(IWGOXS,IRECWR,IBASE(IRECPX),NRECWR)
C----
C  SCATTERING BLOCK
C----
          DO 270 IL=1,NL
            WRITE(CM,'(I2.2)') IL-1
            CALL LCMLEN(IPEDIT,'SCAT'//CM,NRECWR,ILCMTY)
            IF(ILENG .NE. 0) THEN
              CALL LCMGET(IPEDIT,'SCAT'//CM,RBASE(IRECPS))
            ELSE
              CALL XDRSET(RBASE(IRECPS),NGCOND,0.0)
              NRECWR=NGCOND
            ENDIF
C-----
C  TRANSFER INFORMATION TO ISOTXS
C----
            IRECWR=IRECWR+1
            CALL XDRITE(IWGOXS,IRECWR,IBASE(IRECPS),NRECWR)
 270      CONTINUE
          CALL LCMSIX(IPEDIT,NAMISO,2)
        ENDIF
 200  CONTINUE
      CALL RLSARA(IBASE(IRECPS))
      CALL RLSARA(IBASE(IRECPX))
      CALL RLSARA(IBASE(IRECGI))
      CALL RLSARA(RBASE(IRCHI))
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(' STORING ISOTOPE = ',A6,2X,'AT LOCATION = ',I10)
 6001 FORMAT(' HABSID = ',6X,A6/' HIDENT = ',6X,A6/' HMAT   = ',6X,A6/
     >       ' AMASS  = ',E12.5/' EFISS  = ',E12.5/' ECAPT  = ',E12.5/
     >       ' TEMP   = ',E12.5/' SIGPOT = ',E12.5/' ADENS  = ',E12.5/
     >       ' KBR    = ',I12  /' ICHI   = ',I12  /' IFIS   = ',I12  /
     >       ' IALF   = ',I12  /' INP    = ',I12  /' IN2N   = ',I12  /
     >       ' IND    = ',I12  /' INT    = ',I12  /' LTOT   = ',I12  /
     >       ' LTRN   = ',I12  /' ISTRPD = ',I12)
      END
