*DECK LIBA20
      SUBROUTINE LIBA20 (IPLIB,NAMFIL,NGRO,NBISO,NL,ISONAM,ISONRF,
     1 ISHINA,MASKI,TN,SN,SB,IMPX,NGF,NGFR,NDEL,AWR,IPR,ENERG,DELTA,
     2 SECT,SIGS,SCAT,ITYPRO,XSTOT,NFS)
*
*-----------------------------------------------------------------------
*
*Purpose:
* transcription of the useful interpolated microscopic cross section
* data from APOLIB-2 to LCM data structures
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPLIB   pointer to the lattice microscopic cross section library
*         (L_LIBRARY signature)
* NAMFIL  name of the APOLIB-2 file
* NGRO    number of energy groups
* NBISO   number of isotopes present in the calculation domain
* NL      number of Legendre orders required in the calculation
*         NL=1 or higher
* ISONAM  alias name of isotopes
* ISONRF  library reference name of isotopes
* ISHINA  self shielding names
* MASKI   isotopic mask. Isotope with index I is processed if
*         MASKI(I)=.true.
* TN      temperature of each isotope
* SN      dilution cross section in each energy group of each
*         isotope. a value of 1.0E10 is used for infinite dilution
* SB      dilution cross section as used by Livolant and Jeanpierre
*         normalization
* IMPX    print flag
*
*Parameters: output
* NGF     number of fast groups without self-shielding
* NGFR    number of fast and resonance groups
* NDEL    number of precursor groups for delayed neutrons
*
*Parameters: scratch
* AWR
* IPR
* ENERG
* DELTA
* SECT
* SIGS
* SCAT
* ITYPRO
* XSTOT
* NFS
*
*Reference:
*   A. Hebert, P. Bellier, M. Coste, R. Sanchez, Z. Stankovski et
*   I. Zmijarevic, "APOLLO2: Notice informatique Version 2.4",
*   Commissariat a l'Energie Atomique, Rapport SERMA/LENR/RT/98-2477/A,
*   1998.
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPLIB,NGRO,NBISO,NL,ISONAM(3,NBISO),ISONRF(3,NBISO),
     1 ISHINA(3,NBISO),IMPX,NGF,NGFR,NDEL,IPR(7+2*(NL-1),NBISO),
     2 ITYPRO(NL),NFS(NGRO)
      REAL TN(NBISO),SN(NGRO,NBISO),SB(NGRO,NBISO),AWR(NBISO),
     1 ENERG(NGRO+1),DELTA(NGRO),SECT(NGRO),SIGS(NGRO,NL),
     2 SCAT(NGRO,NGRO,NL),XSTOT(NGRO)
      CHARACTER NAMFIL*(*)
      LOGICAL MASKI(NBISO)
*
      CALL XABORT('LIBA20: NOT AVAILABLE IN THIS VERSION OF DRAGON.')
      RETURN
      END
