*DECK XDRCRE
      SUBROUTINE XDRCRE(NAMMOD,IBEAF )
*
*-----------------------------------------------------------------------
*
*Purpose:
* To print DRAGON credits.
*
*Copyright:
* Copyright (C) 2004 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): G. Marleau
*
*Parameters: input
* NAMMOD  name of DRAGON module.
* IBEAF   flag for beginning or finishing module where
*         \begin{itemize} 
*         \item IBEAF=1  before module execution;
*         \item IBEAF=-1 after module execution.
*         \end{itemize} 
*
*-----------------------------------------------------------------------
*
      IMPLICIT         NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER        NAMMOD*12
      INTEGER          IBEAF
*----
*  LOCAL PARAMETERS
*----
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='XDRCRE')
*----
*  LOCAL VARIABLES
*----
      CHARACTER        USE*72,AUT*72
      INTEGER          ICOPYR
*----
*  PRINT CREDITS
*----
      ICOPYR=0
      IF(IBEAF .EQ. 1) THEN
        WRITE(IOUT,6000) NAMMOD
        IF     (NAMMOD .EQ.  'ASM:        ') THEN      
          USE='TO BUILT SYSTEM MATRICES (CP AND IC)'
          AUT='A. HEBERT, G. MARLEAU, R. ROY'
        ELSE IF(NAMMOD .EQ.  'COMPO:      ') THEN      
          USE='CREATE MULTIPARAMETER REACTOR COMPOSITION DATABASE'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'NCR:        ') THEN      
          USE='ACCESS MULTIPARAMETER REACTOR COMPOSITION DATABASE'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'EDI:        ') THEN      
          USE='EDITING MODULE'
          AUT='A. HEBERT, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'EVO:        ') THEN      
          USE='ISOTOPIC DEPLETION AND FUEL BURNUP'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'EXCELT:     ') THEN      
          USE='EXCELL TRACKING IN 2- AND 3-D'
          AUT='G. MARLEAU, M. OUISLOUMEN, R. ROY'
        ELSE IF(NAMMOD .EQ.  'NXT:        ') THEN      
          USE='NEW EXCELL TRACKING IN 2- AND 3-D'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MCCGT:      ') THEN      
          USE='METHOD OF CHARACTERISTICS IN 2- AND 3-D'
          AUT='I. SUSLOV, R. ROY, R. LETELLIER, A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'BIVACT:     ') THEN      
          USE='2-D DIFFUSION OR SPN FINITE ELEMENT TRACKING'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'SNT:        ') THEN      
          USE='DISCRETE ORDINATES TRACKING'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'FLU:        ') THEN      
          USE='SOLVE THE FLUX EQUATIONS'
          AUT='R. ROY, A. HEBERT, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'GEO:        ') THEN      
          USE='GEOMETRY DEFINITION'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'INFO:       ') THEN      
          USE='INFORMATION ON WATER, UO2 AND THO2'
          AUT='R. ROY'
        ELSE IF(NAMMOD .EQ.  'LIB:        ') THEN      
          USE='MICROSCOPIC XS-LIBRARY PROCESSING'
          AUT='A. HEBERT, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MAC:        ') THEN      
          USE='MACROSCOPIC XS PROCESSOR'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MRG:        ') THEN      
          USE='MERGE EXCELL TRACKING FILE'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'PSP:        ') THEN      
          USE='GENERATES PS GRAPHICS FOR DRAGON'
          AUT='K.E. KOHLER, G. MARLEAU'
          ICOPYR=1
        ELSE IF(NAMMOD .EQ.  'SHI:        ') THEN      
          USE='SELF-SHIELDING BY IMPROVED STAMMLER METHOD'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'USS:        ') THEN      
          USE='SELF-SHIELDING BY SUBGROUP METHOD'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'SYBILT:     ') THEN      
          USE='SYBIL 2-D TRACKING'
          AUT='A. HEBERT'
        ELSE
          USE='NO DESCRIPTION AVAILABLE FOR THIS MODULE'
          AUT='NO AUTHOR PROVIDED FOR THIS MODULE'
        ENDIF
        WRITE(IOUT,6100) USE,AUT
        IF(ICOPYR .EQ. 1) THEN
          WRITE(IOUT,6111)
        ELSE
          WRITE(IOUT,6110)
        ENDIF
      ELSE
        WRITE(IOUT,6001) NAMMOD
      ENDIF
      RETURN
*----
*  FORMATS
*----
 6000 FORMAT('->@BEGIN MODULE : ',A12)
 6001 FORMAT('->@END MODULE   : ',A12)
 6100 FORMAT('->@DESCRIPTION  : ',A72/
     >       '->@CREDITS      : ',A72)
 6110 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL  '/
     >       '                  GNU LESSER GENERAL PUBLIC LICENSE')
 6111 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL  '/
     >       '                  GNU LESSER GENERAL PUBLIC LICENSE'/
     >       '                  K.E. KOHLER FOR PSPLOT           ')
      END  
