*DECK XELTBH
      SUBROUTINE XELTBH(IPGEOM,IPTRK,IQUA10,IMPX)
*
*-----------------------------------------------------------------------
*
*Purpose:
* recover the double-heterogeneity (Bihet) data from the geometry
* object IPGEOM and update the tracking object IPTRK.
*
*Copyright:
* Copyright (C) 2005 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPTRK   pointer to the excell tracking (L_TRACK).
* IPGEOM  pointer to the geometry (L_GEOM).
* IQUA10  quadrature parameter for the double heterogeneity option.
* IMPX    tracking print level.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPGEOM,IPTRK,IQUA10,IMPX
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40)
      INTEGER ISTRAK(NSTATE),ISTATE(NSTATE),IPARAM(8)
      COMMON IBASE(1)
*
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTRAK)
      NREG2=ISTRAK(1)
      IR2=ISTRAK(4)
*
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      NG=ISTATE(1)
      NSMAX=ISTATE(2)-1
      CALL SETARA(IBASE,NG,INS)
      CALL LCMGET(IPGEOM,'NS',IBASE(INS))
      NSMAX=0
      DO 10 I=1,NG
   10 NSMAX=MAX(NSMAX,IBASE(INS+I-1))
      MAXPTS=NREG2*(NSMAX+1)*NG
      CALL SETARA(IBASE,MAXPTS,IMAT)
      CALL SETARA(IBASE,MAXPTS,IVOL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',IBASE(IVOL))
      CALL LCMSIX(IPTRK,'BIHET',1)
      CALL LCMPUT(IPTRK,'VOLUME',NREG2,2,IBASE(IVOL))
      CALL LCMSIX(IPTRK,' ',2)
*
      CALL SETARA(IBASE,NREG2,IIBI)
      CALL SETARA(IBASE,NG*(1+NSMAX),IRS)
      CALL SETARA(IBASE,NG*IR2,IFRACT)
      CALL SETARA(IBASE,NG*NSMAX,IVOLK)
      CALL XDRSET(IBASE(IVOLK),NG*NSMAX,0.0)
*
      DO 20 I=1,NREG2
   20 IBASE(IIBI+I-1)=IBASE(IMAT+I-1)
*
      CALL SETARA(IBASE,IR2,IMILIE)
      CALL SETARA(IBASE,IR2,IIDIL)
      CALL SETARA(IBASE,NG*NSMAX*IR2,IITEM)
      CALL SETARA(IBASE,IR2,IFTEMP)
      CALL READBH(MAXPTS,IPGEOM,IR,IR2,NREG,NREG2,IBASE(IMAT),
     1 IBASE(IVOL),NG,NSMAX,MICRO,IBASE(INS),IBASE(IIBI),IBASE(IRS),
     2 IBASE(IFRACT),IBASE(IVOLK),IMPX,IBASE(IMILIE),IBASE(IIDIL),
     3 IBASE(IITEM),IBASE(IFTEMP))
      CALL RLSARA(IBASE(IFTEMP))
      CALL RLSARA(IBASE(IITEM))
      CALL RLSARA(IBASE(IIDIL))
      CALL RLSARA(IBASE(IMILIE))
*
      IF(IMPX.GE.1) WRITE (6,'(/" QUADRATURE PARAMETER FOR THE ",
     1 "MICRO STRUCTURES =",I2/)') IQUA10
*
      IPARAM(1)=IR
      IPARAM(2)=IR2
      IPARAM(3)=NREG2
      IPARAM(4)=NG
      IPARAM(5)=NSMAX
      IPARAM(6)=0
      IPARAM(7)=MICRO
      IPARAM(8)=IQUA10
      CALL LCMSIX(IPTRK,'BIHET',1)
      CALL LCMPUT(IPTRK,'PARAM',8,1,IPARAM)
      CALL LCMPUT(IPTRK,'NS',NG,1,IBASE(INS))
      CALL LCMPUT(IPTRK,'IBI',NREG2,1,IBASE(IIBI))
      CALL LCMPUT(IPTRK,'RS',NG*(1+NSMAX),2,IBASE(IRS))
      CALL LCMPUT(IPTRK,'FRACT',NG*IR2,2,IBASE(IFRACT))
      CALL LCMPUT(IPTRK,'VOLK',NG*NSMAX,2,IBASE(IVOLK))
      CALL LCMSIX(IPTRK,' ',2)
      CALL RLSARA(IBASE(IVOLK))
      CALL RLSARA(IBASE(IFRACT))
      CALL RLSARA(IBASE(IRS))
      CALL RLSARA(IBASE(IIBI))
      CALL RLSARA(IBASE(INS))
*
      CALL LCMPUT(IPTRK,'MATCOD',NREG,1,IBASE(IMAT))
      CALL LCMPUT(IPTRK,'VOLUME',NREG,2,IBASE(IVOL))
      CALL SETARA(IBASE,NREG,IIDL)
      DO 30 I=1,NREG
   30 IBASE(IIDL+I-1)=I
      CALL LCMPUT(IPTRK,'KEYFLX',NREG,1,IBASE(IIDL))
      CALL RLSARA(IBASE(IIDL))
      ISTRAK(1)=NREG
      ISTRAK(2)=NREG
      ISTRAK(4)=IR
      CALL LCMPUT(IPTRK,'STATE-VECTOR',NSTATE,1,ISTRAK)
      CALL RLSARA(IBASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
