*DECK XELTSA
      SUBROUTINE XELTSA(NDIM,ABSC,INDC,DENS,ANGTSA)
************************************************************************
*                                                                      *
*           NAME: XELTSA                                               *
*      COMPONENT: EXCELL                                               *
*          LEVEL: 4 (CALLED BY 'XELTS2')                               *
*        VERSION: 1.0                                                  *
*       CREATION: 90/12                                                *
*       MODIFIED: 00/03 (R.R.) DECLARE ALL VARIABLE TYPES              *
*         AUTHOR: ROBERT ROY                                           *
*                                                                      *
*     SUBROUTINE: THIS ROUTINE WILL COMPUTE THE ANGULAR DIRECTIONS     *
*                 AND THE BASIC DENSITY THAT ARE REQUIRED              *
*                 FOR THE PERIODIC TRACKING OPTION.                    *
*                                                                      *
*--------+-------------- V A R I A B L E S -------------+--+-----------*
*  NAME  /                  DESCRIPTION                 /IO/MOD(DIMENS)*
*--------+----------------------------------------------+--+-----------*
* NDIM   / # OF DIMENSIONS (2 OR 3).                    /I./INT        *
* ABSC   / COORDINATES OF THE GLOBAL GEOMETRY.          /I./INT(NDIM)  *
* INDC   / INDEX IN EACH COORDINATE OF THE ANGLE.       /I./INT(NDIM)  *
* DENS   / THE REQUIRED BASIC DENSITY.                  /.O/R*8        *
* ANGTSA / TRACKING DIRECTION AND ITS PERPENDICULAR.    /.O/R*8(NDIM   *
*        /                                              /  /   *NDIM)  *
************************************************************************
C
      IMPLICIT         NONE
C
      INTEGER          NDIM
      INTEGER          INDC(NDIM)
      DOUBLE PRECISION DENS,ABSC(NDIM),ANGTSA(NDIM,NDIM)
C
      INTEGER          IDIM
C
      IF( NDIM.NE.2 )THEN
         CALL XABORT( 'XELTSA: NDIM=3 NOT AVAILABLE YET' )
      ENDIF
      DENS= 0.0D0
      DO 10 IDIM= 1,NDIM
         ANGTSA(IDIM,1)= INDC(IDIM)/ABSC(NDIM+1-IDIM)
         DENS= DENS + ANGTSA(IDIM,1)*ANGTSA(IDIM,1)
   10 CONTINUE
      DENS= SQRT(DENS)
C
C     ANGTSA(*,1) IS THE TRACK DIRECTION VECTOR (OMEGA)
      DO 20 IDIM= 1,NDIM
         ANGTSA(IDIM,1)= ANGTSA(IDIM,1)/DENS
   20 CONTINUE
C
C     ANGTSA(*,2) IS A VECTOR PREPENDICULAR TO DIRECTION VECTOR
      ANGTSA(2,2)= -ANGTSA(1,1)
      ANGTSA(1,2)=  ANGTSA(2,1)
C
      RETURN
      END
