*DECK FLDPIO
      SUBROUTINE FLDPIO(I1,I2,MAXKN,LL4A,LL4B,NBLOS,IELEM,CTRAN,KN,DIFF,
     > F2,F3)
*
*-----------------------------------------------------------------------
*
*Purpose:
* include the Piolat transform term.
*
*Copyright:
* Copyright (C) 2006 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* I1      orientation of F2 (=1: W; =2: X; =3:Y)
* I2      orientation of F3 (=1: W; =2: X; =3:Y)
* MAXKN   dimension of array KN
* LL4A    dimension of array F2
* LL4B    dimension of array F3
* NBLOS   number of losanges in one swapping direction
* IELEM   degree of the Lagrangian finite elements:
*         =1: linear finite elements or finite differences;
*         =2: parabolic finite elements;
*         =3: cubic finite elements
* CTRAN   Piolat coupling terms
* KN      element-ordered unknown list
* DIFF    I1-oriented diffusion coefficients if MOD(I1+2-I2,3)=0;
*         I2-oriented diffusion coefficients if MOD(I1+2-I2,3)=1
* F2      input currents
*
*Parameters: output
* F3      output currents
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER I1,I2,MAXKN,LL4A,LL4B,NBLOS,IELEM,KN(MAXKN)
      REAL CTRAN(IELEM**2,IELEM**2),DIFF(NBLOS),F2(LL4A),F3(LL4B)
*
      CALL XABORT('FLDPIO: THOMAS-RAVIART-SCHNEIDER NOT IMPLEMENTED.')
      RETURN
      END
