*DECK ALVDLF
      SUBROUTINE ALVDLF (ASS,MU1,ISEG,LON,NBL,LBL,T)
*
*-----------------------------------------------------------------------
*
* IN-PLACE L-D-L(T) FACTORIZATION OF A SYMMETRIC POSITIVE DEFINITE
* MATRIX IN COMPRESSED DIAGONAL STORAGE MODE. SUPERVECTORIAL VERSION
*
* INPUT PARAMETERS:
*     ASS : COEFFICIENT MATRIX IN COMPRESSED DIAGONAL STORAGE MODE.
*           DIMENSION ASS(ISEG,MU1(L4))
*     MU1 : POSITION OF EACH DIAGONAL ELEMENT IN VECTOR ASS.
*           DIMENSION MU1(L4) WHERE L4=SUM(LBL(I))
*    ISEG : NUMBER OF ELEMENTS IN A VECTOR REGISTER.
*     LON : NUMBER OF GROUPS OF LINEAR SYSTEMS.
*     NBL : NUMBER OF LINEAR SYSTEMS IN EACH GROUP. DIMENSION NBL(LON)
*     LBL : NUMBER OF UNKNOWNS IN EACH GROUP. DIMENSION LBL(LON)
*
* OUTPUT PARAMETER:
*     ASS : LDL(T) FACTORS OF THE COEFFICIENT MATRIX.
*
* SCRATCH STORAGE:
*     T : DIMENSION T(ISEG)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 18/05/93 ---
*
      DIMENSION MU1(*),ASS(ISEG,*),NBL(*),LBL(*),T(*)
      LBL0=0
      DO 200 ILON=1,LON
      L4=LBL(ILON)
      NBANC=NBL(ILON)
      DO 10 IB=1,NBANC
   10 ASS(IB,MU1(LBL0+1))=1.0/ASS(IB,MU1(LBL0+1))
      IF (L4.EQ.1) GO TO 200
      DO 110 K=LBL0+2,LBL0+L4
      K1=MU1(K)-K
      KM=MU1(K-1)+1-K1
      IF(KM+1-K) 20,60,100
   20 DO 50 I=KM+1,K-1
      DO 30 IB=1,NBANC
      T(IB)=ASS(IB,K1+I)
   30 ASS(IB,K1+I)=0.0
      I1=MU1(I)-I
      IM=MU1(I-1)+1-I1
      IMIN=MAX0(IM,KM)
      DO 40 J=IMIN,I
      DO 40 IB=1,NBANC
   40 T(IB)=T(IB)-ASS(IB,K1+J)*ASS(IB,I1+J)
      DO 50 IB=1,NBANC
   50 ASS(IB,K1+I)=T(IB)
   60 DO 70 IB=1,NBANC
   70 T(IB)=0.0
      DO 80 I=KM,K-1
      DO 80 IB=1,NBANC
      GAR=ASS(IB,K1+I)
      ASS(IB,K1+I)=GAR*ASS(IB,MU1(I))
   80 T(IB)=T(IB)+GAR*ASS(IB,K1+I)
      DO 90 IB=1,NBANC
   90 ASS(IB,MU1(K))=ASS(IB,MU1(K))-T(IB)
  100 DO 110 IB=1,NBANC
  110 ASS(IB,MU1(K))=1.0/ASS(IB,MU1(K))
  200 LBL0=LBL0+L4
      RETURN
      END
